UNIT XMLCrypt;
interface
uses
    VPUtils,SysUtils, Classes,
    sha256, crypt2, ciphers,blowfish,Base64,dom,xmlread,xmlwrite,CrypUnit;

    function CryptFileToXML(CryptStream:TFileStream;
                            Passphrase:string):TXMLDocument;
    procedure XMLToCryptFile(CryptStream:TFileStream;
                             Passphrase:string;
                             doc:TXMLDocument);
implementation
var
    blow:TDCP_Blowfish;

function CryptFileToXML(CryptStream:TFileStream;
Passphrase:string):TXMLDocument;
var
    MemStream:TMemoryStream;
    Doc:TXMLDocument;
    ChAry:array[1..5] of char;
begin
    MemStream:=TMemoryStream.Create;
    DecryptStream(CryptStream,MemStream,passphrase,blow);
    MemStream.position:=0;
    MemStream.ReadBuffer(ChAry,5);
    IF (ChAry[1]<>'<') or
       (ChAry[2]<>'?') or
       (ChAry[3]<>'x') or
       (ChAry[4]<>'m') or
       (ChAry[5]<>'l') THEN BEGIN
        result:=Nil;
    END
    ELSE BEGIN
        memStream.position:=0;
        ReadXMLFileStream(Doc,TStream(MemStream));
        MemStream.free;
        result:=Doc;
    END;
end;
procedure XMLToCryptFile(CryptStream:TFileStream;Passphrase:string;doc:TXMLDocument);
var
    MemStream:TMemoryStream;
begin
    MemStream:=TMemoryStream.Create;
    WriteXMLFileStream(Doc,TStream(MemStream));
    MemStream.position:=0;
    EncryptStream(MemStream,CryptStream,passphrase,blow);
end;
begin
    blow:=tdcp_blowfish.create;
end.
